%define major   3
%define libname %mklibname %{name} %{major}
%define devname %mklibname %{name} -d

# build deprecated tools
# hciattach hciconfig hcitool hcidump rfcomm sdptool ciptool gatttool
%bcond_without deprecated

Name:           bluez
Summary:        Official Linux Bluetooth protocol stack
Version:        5.75
Release:        %mkrel 1
License:        GPLv2+
Group:          Communications
URL:            http://bluez.org/
Source0:        http://www.kernel.org/pub/linux/bluetooth/%{name}-%{version}.tar.xz
Source1:        input.conf
Source2:        main.conf
Source3:        bluetooth
Patch40:        0001-work-around-Logitech-diNovo-Edge-keyboard-firmware-i.patch
Patch51:        0001-obex-Use-GLib-helper-function-to-manipulate-paths.patch
Patch52:        0004-agent-Assert-possible-infinite-loop.patch
Patch102:       CVE-2016-9804-tool-hcidump-Fix-memory-leak-with-malformed-packet.patch
BuildRequires: libical-devel
BuildRequires: lib64readline-devel
BuildRequires: lib64json-devel
BuildRequires: lib64cap-ng-devel
BuildRequires: lib64ell-devel
BuildRequires: python-docutils
Obsoletes: bluez-daemon
Requires: bluez-firmware
Requires: bluez-firmware-broadcom
Requires: daemonize

%description
These are the official Bluetooth communication libraries for Linux.

%pre
rm -f %{_sysconfdir}/bluetooth/*.conf > /dev/null 2>&1
rm -f %{_sysconfdir}/default/bluetooth > /dev/null 2>&1

%post
### remove these lines and replace it below
sed -i '/rfkill/ d' /etc/rc.d/rc.local > /dev/null 2>&1
sed -i '/hciconfig/ d' /etc/rc.d/rc.local > /dev/null 2>&1
sed -i '/daemonize/ d' /etc/rc.d/rc.local > /dev/null 2>&1
sed -i -e :a -e '/^\n*$/{$d;N;ba' -e '}' /etc/rc.d/rc.local > /dev/null 2>&1

echo -e '\nrfkill unblock all'  >> /etc/rc.d/rc.local 
echo -e 'hciconfig hci0 up'  >> /etc/rc.d/rc.local 
echo -e 'daemonize /usr/bin/bluetoothd &'  >> /etc/rc.d/rc.local

#remove old symlinks
rm -f /etc/rc.d/rc*.d/*bluez*

# Ensure that the old broken dangling link will be removed from users system (mga#17682)
# NOTE can be removed for mga7
update-alternatives --remove bluepin /usr/bin/bluepin || :


%files
%{_sysconfdir}/bluetooth/*.conf
%{_sysconfdir}/bluetooth/pin
%{_sysconfdir}/modprobe.d/bluetooth-usb.conf
%{_sysconfdir}/default/bluetooth
%{_sysconfdir}/modprobe.preload.d/10-bluetooth
%{_bindir}/isotest
%{_bindir}/bluetoothd
%{_bindir}/obexd
%{_bindir}/btattach
%{_bindir}/l2ping
%{_bindir}/bluetoothctl
%{_bindir}/bluemoon
%{_bindir}/btmon
%{_datadir}/dbus-1/system.d/bluetooth.conf

%if %{with deprecated}
%{_bindir}/hciattach
%{_bindir}/hciconfig
%{_bindir}/hcitool
%{_bindir}/hcidump
%{_bindir}/rfcomm
%{_bindir}/sdptool
%{_bindir}/ciptool
%endif
%{_bindir}/hex2hcd
%{_bindir}/l2test
%{_bindir}/mpris-proxy
%{_bindir}/rctest
%dir %{_libexecdir}/bluetooth/
%{_libexecdir}/bluetooth/bluetoothd
%{_libexecdir}/bluetooth/obexd

%{_localstatedir}/lib/bluetooth
%{_datadir}/dbus-1/system-services/org.bluez.service
%{_datadir}/dbus-1/services/org.bluez.obex.service
%{_datadir}/zsh/site-functions/_bluetoothctl
%{_datadir}/man/man1/btmon.1.bz2
%{_mandir}
#--------------------------------------------------------------------

%package        cups
Summary:        CUPS printer backend for Bluetooth printers
Group:          System/Printing
BuildRequires:  cups-devel

%description    cups
This package contains the CUPS backend for Bluetooth printers.

%files cups
%{_prefix}/lib/cups/backend/bluetooth

#--------------------------------------------------------------------

%package hid2hci
Summary: Put HID proxying bluetooth HCI's into HCI mode
Group: Communications

%description hid2hci
Most allinone PC's and bluetooth keyboard / mouse sets which include a
bluetooth dongle, ship with a so called HID proxying bluetooth HCI.
The HID proxying makes the keyboard / mouse show up as regular USB HID
devices (after connecting using the connect button on the device + keyboard),
which makes them work without requiring any manual configuration.

The bluez-hid2hci package contains the hid2hci utility and udev rules to
automatically switch supported Bluetooth devices into regular HCI mode.

Install this package if you want to use the bluetooth function of the HCI
with other bluetooth devices like for example a mobile phone.

Note that after installing this package you will first need to pair your
bluetooth keyboard and mouse with the bluetooth adapter before you can use
them again. Since you cannot use your bluetooth keyboard and mouse until
they are paired, this will require the use of a regular (wired) USB keyboard
and mouse.

%files hid2hci
/lib/udev/hid2hci
/lib/udev/rules.d/97-hid2hci.rules

%post hid2hci
/sbin/udevadm trigger --subsystem-match=usb > /dev/null 2>&1

#--------------------------------------------------------------------

%package -n     %{libname}
Summary:        Official Linux Bluetooth protocol stack
Group:          System/Libraries

%description -n %{libname}
These are the official Bluetooth communication libraries for Linux.

%files -n %{libname}
%{_libdir}/lib*.so.%{major}*

#--------------------------------------------------------------------

%package -n     %{devname}
Summary:        Headers for developing programs that will use %{name}
Group:          Development/Libraries
Requires:       %{libname} = %{version}
Provides:       lib%{name}-devel = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
Provides:       bluez-devel = %{version}-%{release}

%description -n %{devname}
This package contains the headers that programmers will need to develop
applications which will use libraries from %{name}.

%files -n %{devname}
%{_includedir}/bluetooth
%{_libdir}/*.so
%{_libdir}/pkgconfig/bluez.pc

#--------------------------------------------------------------------

%prep
%setup -q
%autopatch -p1

%build
autoreconf -fi
%define _localstatedir /var
%configure2_5x \
    --enable-external-ell \
	--with-udevdir=/lib/udev \
	--disable-systemd \
	--with-systemdsystemunitdir=no \
	--with-systemduserunitdir=no \
    --enable-cups \
    --enable-tools \
    --enable-library \
    --enable-sixaxis \
    --enable-nfc \
    --enable-hid2hci \
    --enable-bap \
    --enable-bass \
    --enable-mcp \
    --enable-micp \
    --enable-csip \
    --enable-vcp \
    %{?with_deprecated:--enable-deprecated}

%make_build

%install
rm -rf %buildroot
%make_install

# Remove the cups backend from libdir, and install it in /usr/lib whatever the install
%ifarch x86_64
if test -d %{buildroot}%{_libdir}/cups ; then
    install -D -m0755 %{buildroot}%{_libdir}/cups/backend/bluetooth %{buildroot}/usr/lib/cups/backend/bluetooth
    rm -rf %{buildroot}%{_libdir}/cups
fi
%endif

#are these needed?
install -Dm 0644 tools/hid2hci.rules %{buildroot}/lib/udev/rules.d/97-hid2hci.rules

#install more config files
install -d -m 0755 %{buildroot}%{_sysconfdir}/bluetooth
install -m 0644 %SOURCE1 %{buildroot}%{_sysconfdir}/bluetooth/input.conf
install -m 0644 %SOURCE2 %{buildroot}%{_sysconfdir}/bluetooth/main.conf
install -m 644 profiles/network/network.conf %{buildroot}%{_sysconfdir}/bluetooth/network.conf

install -d -m 0755 %{buildroot}%{_sysconfdir}/default
install -m 0644 %SOURCE3 %{buildroot}%{_sysconfdir}/default/bluetooth

echo "1234" > %{buildroot}%{_sysconfdir}/bluetooth/pin
chmod 600 %{buildroot}%{_sysconfdir}/bluetooth/pin

# install modprobeconf from aur
install -d -m 755 %{buildroot}%{_sysconfdir}/modprobe.d
%__cat <<EOF > %{buildroot}%{_sysconfdir}/modprobe.d/bluetooth-usb.conf
options btusb reset=1
EOF

# https://bugzilla.kernel.org/show_bug.cgi?id=196621
install -d -m 755 %{buildroot}%{_sysconfdir}/modprobe.preload.d
%__cat <<EOF > %{buildroot}%{_sysconfdir}/modprobe.preload.d/10-bluetooth
crypto_user
EOF

# remove unpackaged files
find %{buildroot} -name '*.la' -delete

install -d -m0755 %{buildroot}%{_localstatedir}/lib/bluetooth

ln -fs %{_libexecdir}/bluetooth/bluetoothd %{buildroot}%{_bindir}/bluetoothd
ln -fs %{_libexecdir}/bluetooth/obexd %{buildroot}%{_bindir}/obexd

install -D -p -m0644 src/org.bluez.service %{buildroot}%{_datadir}/dbus-1/system-services/org.bluez.service
# correctings
%__cat <<EOF > %{buildroot}%{_datadir}/dbus-1/system-services/org.bluez.service
[D-BUS Service]
Name=org.bluez
Exec=/usr/bin/bluetoothd
User=root
EOF

install -D -p -m0644 obexd/src/org.bluez.obex.service %{buildroot}%{_datadir}/dbus-1/services/org.bluez.obex.service
# correctings
%__cat <<EOF > %{buildroot}%{_datadir}/dbus-1/services/org.bluez.obex.service
[D-BUS Service]
Name=org.bluez.obex
Exec=/usr/bin/obexd
EOF

%changelog
* Mon Apr 15 2024 tex - 5.75-1pclos2024
- new version

* Sun Apr 14 2024 tex - 5.74-1pclos2024
- new version

* Thu Mar 14 2024 tex - 5.73-1pclos2024
- new version
- new patches
- new build options

* Thu Dec 28 2023 tex - 5.71-2pclos2023
- add patch 8 and 9

* Thu Dec 14 2023 tex - 5.71-1pclos2023
- new version

* Fri Sep 29 2023 tex - 5.70-1pclos2023
- new version

* Sun Sep 17 2023 tex - 5.69-1pclos2023
- new version
